org.jgroups.protocols.pbcast

## Class FLUSH

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.pbcast.FLUSH

    public class FLUSH
    extends Protocol

Flush, as it name implies, forces group members to flush their pending messages while blocking them to send any additional messages. The process of flushing acquiesces the group so that state transfer or a join can be done. It is also called stop-the-world model as nobody will be able to send messages while a flush is in process.

Flush is needed for:

(1) State transfer. When a member requests state transfer, the coordinator tells everyone to stop sending messages and waits for everyone's ack. Then it asks the application for its state and ships it back to the requester. After the requester has received and set the state successfully, the coordinator tells everyone to resume sending messages.

(2) View changes (e.g.a join). Before installing a new view V2, flushing would ensure that all messages *sent* in the current view V1 are indeed *delivered* in V1, rather than in V2 (in all non-faulty members). This is essentially Virtual Synchrony.

Since:
  2.4
Author:
  Vladimir Blagojevic

### Nested Class Summary

Nested Classes
`static class` `FLUSH.FlushHeader`

### Field Summary

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`FLUSH()`

### Method Summary

Methods
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`double` `getAverageFlushDuration()`
`int` `getNumberOfFlushes()`
`long` `getRetryTimeout()`
`long` `getStartFlushTimeout()`
`long` `getTotalTimeInFlush()`
`java.util.Vector<java.lang.Integer>` `providedDownServices()` List of events that are provided to layers below (they will be handled when sent down from below).
`void` `setRetryTimeout(long retry_timeout)`
`void` `setStartFlushTimeout(long start_flush_timeout)`
`void` `start()` This method is called on a `Channel.connect(String)`.
`boolean` `startFlush()`
`void` `stop()` This method is called on a `Channel.disconnect()`.
`void` `stopFlush()`
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, init, isErgonomics, printStats, providedUpServices, requiredDownServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### FLUSH

    public FLUSH()

### Method Detail

#### getStartFlushTimeout

    public long getStartFlushTimeout()

#### setStartFlushTimeout

    public void setStartFlushTimeout(long start_flush_timeout)

#### getRetryTimeout

    public long getRetryTimeout()

#### setRetryTimeout

    public void setRetryTimeout(long retry_timeout)

#### start

    public void start()
               throws java.lang.Exception

Description copied from class: `Protocol`
This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

Overrides:
  `start` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### getAverageFlushDuration

    public double getAverageFlushDuration()

#### getTotalTimeInFlush

    public long getTotalTimeInFlush()

#### getNumberOfFlushes

    public int getNumberOfFlushes()

#### startFlush

    public boolean startFlush()

#### stopFlush

    public void stopFlush()

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`

#### providedDownServices

    public java.util.Vector<java.lang.Integer> providedDownServices()

Description copied from class: `Protocol`
List of events that are provided to layers below (they will be handled when sent down from below).

Overrides:
  `providedDownServices` in class `Protocol`
Returns:
  Vector<Integer (of Integers)